;*****************************************************************************/
;*                                                                           */
;* CEQUIV.ASM - Support file for assembly implementation of the "The VGA     */
;*              Trainer Program" written by Denthor of Asphyxia. ASM written */
;*              by Ossa (Robert Cassels).                                    */
;*                                                                           */
;*****************************************************************************/

.MODEL SMALL, C
.386
.DOSSEG
OPTION CASEMAP:NONE

; --------------
; Get the header
; --------------

INCLUDE CEQUIV.INC

; ------------------------
; Initialised data section
; ------------------------

.DATA

nrandom_seed		dw			12345				; Seed for rand()

.CODE

; #############################################################################
; rand() - This function produces one word length random number.
; #############################################################################

rand PROC
	mov ax, nrandom_seed
	mov dx, ax
	shr dx, 5
	xor ax, dx
	shr dx, 6
	xor ax, dx
	shr dx, 4
	xor ax, dx
	and ax, 0001h
	mov dx, nrandom_seed
	shl dx, 1
	add ax, dx
	mov nrandom_seed, ax

    ret
rand ENDP

; #############################################################################
; srand() - This function sets the random number seed.
; #############################################################################

srand PROC TheSeed:WORD
    mov ax, TheSeed
    mov nrandom_seed, ax

    ret
srand endp

; #############################################################################
; getch() - This function gets a character from the keyboard.
; #############################################################################

getch PROC
	mov ah, 00h
	int 16h
	ret
getch ENDP

; #############################################################################
; clrscr() - This function clears the screen in text mode.
; #############################################################################

clrscr PROC
	mov ax, 0B800h
	mov es, ax
	xor di, di
	xor al, al
	mov cx, (80*25)
@@:
	rep stosb

	ret
clrscr ENDP

; #############################################################################
; outstr() - This function displays a NULL terminated string.
; #############################################################################

outstr PROC pstr:WORD
	mov ax, DGROUP
	mov es, ax
	
	mov si, pstr
@@:
	lodsb
	
	or	al, al
	jz	@F

	push si
	
	mov	ah, 0Eh
	int	10h
	
	pop	si
	jmp	@B
@@:
	ret
outstr ENDP

; #############################################################################
; kbhit() - This function returns whether or not a keystroke is available.
; #############################################################################

kbhit PROC
	mov ah, 01h
	int 16h
	
	; ZF set if NO keystroke
	
	jnz @F
	
	; ZF set, so no keystroke
	
	xor ax, ax
	ret
@@:

	; ZF clear, so keystroke

	mov ax, 0FFFFh
	ret
kbhit ENDP

; #############################################################################
; abs() - This function returns the absolute value of a number.
; #############################################################################

abs PROC a:WORD
	mov ax, a
	cmp ax, 0
	jnl @F
	neg ax
@@:
	ret
abs ENDP

END