;*****************************************************************************/
;*                                                                           */
;* TUTPROG1.CPP - VGA Trainer Program 1 (in Turbo C++ 3.0)                   */
;*                                                                           */
;* "The VGA Trainer Program" is written by Denthor of Asphyxia.  However it  */
;* was limited to Pascal only in its first run.  All I have done is taken    */
;* his original release, translated it to C++, and touched up a few things.  */
;* I take absolutely no credit for the concepts presented in this code, and  */
;* am NOT the person to ask for help if you are having trouble.              */
;*                                                                           */
;* Program Notes : This program presents some basic video concepts: kicking  */
;*                 the computer into graphics mode, testing out two differ-  */
;*                 ent methods of putting pixels to the screen, and finally  */
;*                 re-entering text mode.                                    */
;*                                                                           */
;*                 If you are compiling this code command line, be sure to   */
;*                 use the "-ml" parameter (large memory model).  Otherwise, */
;*                 the program will compile and link, but will lock your     */
;*                 system upon execution.                                    */
;*                                                                           */
;* Author        : Grant Smith (Denthor)      - smith9@batis.bis.und.ac.za   */
;* Translated by : Christopher (Snowman) Mann - r3cgm@dax.cc.uakron.edu      */
;*                                                                           */
;* Last Modified : October 21st, 1994                                        */
;*                                                                           */
;*****************************************************************************/

;*****************************************************************************/
;*                                                                           */
;*         Translated to ASM by Robert Cassels (Ossa) : June 2006            */
;*                                                                           */
;*****************************************************************************/

.MODEL SMALL, C
.386
.DOSSEG
.STACK 200h

INCLUDE CEQUIV.INC

SetMCGA				PROTO
SetText				PROTO
Cls					PROTO Col:BYTE
TestINTPutpixel		PROTO
TestMEMPutpixel		PROTO
INTPutpixel			PROTO x:WORD, y:WORD, Col:BYTE
MEMPutpixel			PROTO x:WORD, y:WORD, Col:BYTE

.DATA

szBegin				db			"What will happen is that I will clear the screen twice.  After", 0Dh, 0Ah
					db			"each clear screen you will have to hit a key.  I will then fill", 0Dh, 0Ah
					db			"the screen twice with randomly colored pixels using 2 different", 0Dh, 0Ah
					db			"methods, after each of which you will have to hit a key. I will", 0Dh, 0Ah
					db			"then return you to text mode.", 0Dh, 0Ah, 0Ah
					db			"Hit any key to continue ...", 0Dh, 0Ah, 0

szEnd				db			"All done. This concludes the 1st sample program in the ASPHYXIA", 0Dh, 0Ah
					db			"Training series. You may reach DENTHOR under the name of GRANT", 0Dh, 0Ah
					db			"SMITH on the MailBox BBS, or leave a message to ASPHYXIA on the", 0Dh, 0Ah
					db			"ASPHYXIA BBS. Get the numbers from Roblist, or write to :", 0Dh, 0Ah
					db			"             Grant Smith", 0Dh, 0Ah
					db			"             P.O. Box 270", 0Dh, 0Ah
					db			"             Kloof", 0Dh, 0Ah
					db			"             3640", 0Dh, 0Ah
					db			"I hope to hear from you soon!", 0Dh, 0Ah, 0Dh, 0Ah, 0Dh, 0Ah
					db			"Hit any key to exit ...", 0

.CODE

; #############################################################################
; SetMCGA() - This function gets you into 320x200x256 mode.
; #############################################################################

SetMCGA PROC
	mov ax, 0013h
	int 10h
	ret
SetMCGA ENDP

; #############################################################################
; SetText() - This function gets you into text mode.
; #############################################################################

SetText PROC
	mov ax, 0003h
	int 10h
	ret
SetText ENDP

; #############################################################################
; Cls() - This clears the screen to the specified color.
; #############################################################################

Cls PROC Col:BYTE
	mov ax, 0A000h
	mov es, ax
	xor di, di
	mov al, Col
	mov cx, (320*200)
@@:
	rep stosb
	ret
Cls ENDP

; #############################################################################
; INTPutpixel() - This puts a pixel on the screen using inturrupts.
; #############################################################################

INTPutpixel PROC x:WORD, y:WORD, Col:BYTE
	mov ah, 0Ch
	mov al, Col
	mov cx, x
	mov dx, y
	mov bx, 0001h
	int 10h
	ret
INTPutpixel ENDP

; #############################################################################
; TestINTPutpixel() - This tests out the speed of the INTPutpixel function.
; #############################################################################

TestINTPutpixel PROC
	LOCAL loop1:WORD
	LOCAL loop2:WORD

	mov loop1, 0
TestINTPutpixel_loop1:

	mov loop2, 0
TestINTPutpixel_loop2:
	
	invoke rand
	invoke INTPutpixel, loop1, loop2, al
	
	add loop2, 1
	cmp loop2, 200
	jne TestINTPutpixel_loop2

	add loop1, 1
	cmp loop1, 320
	jne TestINTPutpixel_loop1
	
	ret
TestINTPutpixel ENDP

; #############################################################################
; MEMPutpixel() - This puts a pixel on the screen by writing directly to
;                 memory.
; #############################################################################

MEMPutpixel PROC x:WORD, y:WORD, Col:BYTE
	mov ax, 0A000h
	mov es, ax
	
	mov ax, y
	mov cx, 320
	mul cx
	mov bx, ax
	add bx, x
	mov dl, Col
	mov es:[bx], dl
	
	ret
MEMPutpixel ENDP

; #############################################################################
; TestMEMPutpixel() - This tests out the speed of the MEMPutpixel function.
; #############################################################################

TestMEMPutpixel PROC
	LOCAL loop1:WORD
	LOCAL loop2:WORD

	mov loop1, 0
TestMEMPutpixel_loop1:

	mov loop2, 0
TestMEMPutpixel_loop2:
	
	invoke rand
	invoke MEMPutpixel, loop1, loop2, al
	
	add loop2, 1
	cmp loop2, 200
	jne TestMEMPutpixel_loop2

	add loop1, 1
	cmp loop1, 320
	jne TestMEMPutpixel_loop1
	
	ret
TestMEMPutpixel ENDP

; #############################################################################
;                                  ENTRY POINT
; #############################################################################

	.STARTUP

	invoke clrscr
	invoke outstr, offset szBegin
	invoke getch

	invoke SetMCGA
	invoke Cls, 32
	invoke getch
	invoke Cls, 90
	invoke getch
	invoke TestINTPutpixel
	invoke getch
	invoke Cls, 0
	invoke getch
	invoke TestMEMPutpixel
	invoke getch
	invoke Cls, 0
	invoke SetText

	invoke outstr, offset szEnd
	invoke getch

	.EXIT
	
END
